#ifndef StatsResult_H
#define StatsResult_H

/* --8<--8<--8<--8<--
 *
 * Copyright (C) 2006 Smithsonian Astrophysical Observatory
 *
 * This file is part of rdbstats
 *
 * rdbstats is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * rdbstats is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the 
 *       Free Software Foundation, Inc. 
 *       51 Franklin Street, Fifth Floor
 *       Boston, MA  02110-1301, USA
 *
 * -->8-->8-->8-->8-- */

#include <Exception/Exception.h>

#include "SelectedCols.h"

/**
 * A container class to hold the relevant data for the rdb data columns.
 */
template <class Type>
class StatsResult {

public:

  virtual ~StatsResult( ) { }

  StatsResult( Type& col, RDB& otable );

  void calculate_statistics( );

  void update_statistics( );

protected:

  /// The reference to the selected rdb data column.
  Type& rdb_stats_columns;

  /// The reference to the output rdb table.
  RDB& ordbtable;

};

#ifndef StatsResult_cc
#include "StatsResult.cc"
#endif

#endif
